/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is WebMail Notifier.
 *
 * The Initial Developer of the Original Code is
 * Byungwook Kang.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

const dout=Components.utils.reportError;

if(!com) var com={};
if(!com.tobwithu) com.tobwithu={};
com.tobwithu.wmn = {
  mailInfo:[],

  onClick: function(aEvent) {
    if (aEvent &&(aEvent.button == 2||(aEvent.button ==0&&aEvent.ctrlKey)))
      return;
    if(aEvent &&((aEvent.button == 0&&aEvent.shiftKey)||aEvent.button == 1)){
      this.onCheckNow();
      return;
    }
    if(this._getBoolPref("keepAlert"))this.closeWindow("alert:alert","wmn_alert");
    if(this.mailInfo.length==1){
      this.nsIWebMailNotifier.openMail(this.mailInfo[0].ind,null);
      return;
    }
    var openAll=aEvent && (aEvent.button == 0&&(aEvent.altKey||aEvent.metaKey));
    this.nsIWebMailNotifier.openMails(openAll);
  },
  onCheckNow: function() {
    this.nsIWebMailNotifier.checkMails(false);
  },
  onContextMenu: function() {
    document.getElementById("wmn-window").collapsed=!this._getBoolPref("menuWindow");
    var em=document.getElementById("wmn-sidebar");
    if(em)em.collapsed=!this._getBoolPref("menuSidebar");
  },
  onOpenWMN: function() {
    this.nsIWebMailNotifier.openWMN();
  },
  onPreferences: function() {
    this.nsIWebMailNotifier.openOptions();
  },

  _getBoolPref: function(name){
    var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService);
    var branch = prefService.getBranch("extensions.wmn.");
    branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
    return branch.getBoolPref(name);
  },
  openMail: function(ind,aEvent,folder) {
    if(aEvent && aEvent.shiftKey)this.nsIWebMailNotifier.checkMail(ind);
    else this.nsIWebMailNotifier.openMail(ind,folder);
  },

  /***********************************************************
  WebMailListener implementation
  ***********************************************************/
  onStateChange: function(aIndex,aCount,aData){
    if(aIndex==Components.interfaces.nsIWebMailNotifier.ST_INIT){
      this.initCount();
    }else if(aIndex==Components.interfaces.nsIWebMailNotifier.ST_SHOWICON){
      document.getElementById("wmn-statusbar").collapsed=aCount==0;
      return;
    }else if(aIndex==Components.interfaces.nsIWebMailNotifier.ST_RESET){//accounts change
      this.initCount();
    }else{
      var obj=decodeObject(this.nsIWebMailNotifier.getAccountInfo(aIndex));
      for(var i in this.mailInfo){
        var o=this.mailInfo[i];
        if(o.id==obj.id&&o.user==obj.user){
          o.mailCount=aCount;
          o.mailData=decodeObject(aData);
          var menu=document.getElementById("wmn-context-menu").childNodes[i];
    //      menu.setAttribute("image",aCount>0?"chrome://wmn/content/mail-new.png":"");
          menu.setAttribute("style","font-weight:"+(aCount>0?"bold":"normal")+(aCount<0?";color:GrayText":""));
          if(aCount>=0){
            menu.setAttribute("class","menuitem-iconic bookmark-item");
          }else{
            menu.removeAttribute("class");
          }
          break;
        }
      }
    }
    var total=makeTooltip(this.nsIWebMailNotifier,document.getElementById("wmn-tooltip-text"),this.mailInfo);

    var elm=document.getElementById("wmn-statusbar");
    elm.setAttribute("newMail", total>0);
    elm.setAttribute("label",total>0?total:"");
    elm=document.getElementById("wmn-toolbar-button");
    if(elm){
      elm.setAttribute("newMail", total>0);
      elm.setAttribute("value",total>0?total:"");
    }
  },

  openCaptchaDialog: function(host,user,arg) {
    var params = {inn:{host:this.nsIWebMailNotifier.getHostName(host),user:user,secimage:"https://ab.login.yahoo.com/img/"+arg+".jpg"}, out:null};
    var features = "chrome,titlebar,toolbar,centerscreen,modal";
    window.openDialog("chrome://wmn/content/captcha.xul","",features,params).focus();
    if (params.out)return params.out.secword;
    else return null;
  },
  showAlertNotification: function(total){
    window.openDialog("chrome://wmn/content/alert.xul","wmn_alert",
        "chrome,dialog=yes,titlebar=no,popup=yes",
        this.mailInfo,this).focus();
  },
  /**********************************************************/
  closeWindow: function(type,name){
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
             .getService(Components.interfaces.nsIWindowMediator);
    var enm = wm.getEnumerator(type);
    while(enm.hasMoreElements()){
      var win = enm.getNext();
      if(win.name==name){
        win.close();
        return;
      }
    }
  },
  initCount: function() {
      var menu=document.getElementById("wmn-context-menu");
      var sep=document.getElementById("wmn-menu-sep");

      for(var i = 0; i < this.mailInfo.length; i++)menu.removeChild(menu.firstChild);
      var n=this.nsIWebMailNotifier.getAccountsNumber();
      this.mailInfo=[];
      for(var i=0;i<n;i++){
        if(!this.nsIWebMailNotifier.isAccountEnabled(i))continue;
        var obj=decodeObject(this.nsIWebMailNotifier.getAccountInfo(i));
        this.mailInfo.push(obj);
      }
    for(var i in this.mailInfo){
      var o=this.mailInfo[i];
      o.mailCount=0;
      o.name=getAccountName(this.nsIWebMailNotifier,o);
      var mi = document.createElement("menuitem");
      mi.setAttribute("label",o.name);
      mi.setAttribute("oncommand","com.tobwithu.wmn.openMail("+o.ind+",event)");
      mi.setAttribute("style","color:GrayText");
      mi.setAttribute("image",this.nsIWebMailNotifier.getIconURL(o.id,o.user));
      menu.insertBefore(mi,sep);
    }
  },  
  onLoad: function() {
    var em=document.getElementById("key_openSidebar_wmn");
    if(em){
      var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                  .getService(Components.interfaces.nsIPrefService);
      var prefBranch = prefService.getBranch("extensions.wmn.shortcut.sidebar.");    
      em.setAttribute("key",prefBranch.getCharPref("key"));
      em.setAttribute("modifiers",prefBranch.getCharPref("modifiers"));
    }
    //em=document.getElementById("wmn-statusbar");
    //em=document.getElementById("wmn-toolbarbutton-text");
    //em.setAttribute("style","color:red;font-size:12px;background-color:blue");

    if(!com.tobwithu.wmn._getBoolPref("showStatusbarIcon"))document.getElementById("wmn-statusbar").collapsed=true;
    try {
      com.tobwithu.wmn.nsIWebMailNotifier = Components.classes["@mozilla.org/WebMailNotifier;1"]
                                                  .getService(Components.interfaces.nsIWebMailNotifier);
      com.tobwithu.wmn.nsIWebMailNotifier.addListener(com.tobwithu.wmn);
    } catch (e){
dout(e);
    }
    window.removeEventListener("load", com.tobwithu.wmn.onLoad, false);
  },

  onUnload: function() {
    if (com.tobwithu.wmn.nsIWebMailNotifier)com.tobwithu.wmn.nsIWebMailNotifier.removeListener(com.tobwithu.wmn);
  }
};

window.addEventListener("load", com.tobwithu.wmn.onLoad, false);
window.addEventListener("unload", com.tobwithu.wmn.onUnload, false);